3 - Paths and Cycles - Semantic Scholar

Report 2 Downloads 147 Views
3 - Paths and Cycles Jacques Verstra¨ete [email protected]

1

Trees, forests and cycles

A forest is an acyclic graph. If F is any forest with k ≥ vertices, then it is fairly straightforward to show ex(n, F ) ≤ (k − 1)n since any n-vertex graph with at least (k − 1)n edges has a subgraph of minimum degree at least k where the forest F can be embedded. The celebrated Erd˝os-S´os Conjecture [8] states that if T is any tree with k edges, then ex(n, T ) ≤ 12 (k − 1)n. This conjecture was recently proved by Ajtai, Koml´os, Simonovits and Szemer´edi. In these notes we will show how to prove the Erd˝os-S´os conjecture for paths.

1.1

Cores

The k-core of a graph G is the subgraph obtained by repeatedly removing any vertex of degree less than k. The k-core of a graph is the unique induced subgraph of minimum degree at least k with a maximum number of vertices. Note that we allow the k-core of a graph to be empty, in the event that the graph has no subgraph of minimum degree at least k. Graphs whose k-core is empty are referred to as k-degenerate. It is not hard to classify the extremal n-vertex graphs with no (k + 1)-core. Specifically, for k ≤ m ≤ n, we write Hk,m,n for the graph consisting of a clique on a set T of m vertices plus all edges between a subset of k vertices in T and S = V (Hk,m,n )\T , where S is an independent set of n − m vertices. By inspection, Hk,m,n contains no (k + 1)-core with at least m + 1 vertices, and Hk,k,n is k-degenerate.

1



,

Km

k Figure 1: Cores and Hk,m,n . We make repeated use of the following proposition (see also Proposition 12 in Lecture Notes 1) which says that the graphs Hk,m,n are extremal graphs with no (k + 1)-core with at least m + 1 vertices. Proposition 1. Let k, m ≥ 1, and let G be an n-vertex graph with at least k(n − ( ) m) + m 2 edges. Then G has a (k + 1)-core with at least m + 1 vertices, unless k ≤ m and G = Hk,m,n . In particular, the maximum number of edges in a k-degenerate ( ) n-vertex graph with n ≥ k is k(n − k) + k2 , with equality only for Hk,k,n .

1.2

Hamiltonian paths and cycles

A path/cycle in a graph G is hamiltonian if it contains all vertices of G. A graph is hamiltonian if it contains a hamiltonian cycle. Recall the length of a path or cycle is the number of edges in it. The ends of a path P are the unique vertices of degree 1 on P . If P has ends u and v and we orient P from u to v, then P is called a uvpath. If x ∈ V (P ), let x+ and x− denote the immediate successor and immediately predecessor of x on P respectively. For a set S ⊂ V (P ), let S + = {x+ : x ∈ S}. Define S − similarly. If e ∈ E(G) and H ⊂ G, we write H + e for the graph with vertex set V (H) ∪ e and edge set E(H) ∪ {e}. One of the basic ideas in finding long paths and cycles in a graph is the following lemma: Lemma 2. Let P be a longest path in a graph G. If P is a uv-path, then for any w ∈ NG (v), P ′ = P − {w, w+ } + {v, w} is a uw+ -path that is a longest path in G. Proof. Since P is a longest path, NG (v) ⊆ V (P ). Then P ′ has the same length as P so P ′ is a longest path. 2

The operation of passing from P to P ′ is sometimes called a rotation. Note that a rotation preserves the first vertex u of P . Lemma 3. Let P be a longest path in a connected graph G, and let C ⊆ G be a cycle with |V (P )| = |V (C)|. Then C is a hamiltonian cycle of G. Proof. If C is not a hamiltonian cycle of G, pick a vertex w ∈ V (G)\V (C) adjacent to a vertex v ∈ V (C). If u is adjacent to v on C, then C − {u, v} + {v, w} is a path of length |E(P )| + 1, contradicting that P is a longest path. The following was proved by Ore [10], generalizing an earlier theorem of Dirac [4]: Theorem 4. Let n ≥ 3, and let G be an n-vertex graph such that for any pair u, v of non-adjacent vertices of G, dG (u) + dG (v) ≥ n. Then G is hamiltonian. In particular, for n ≥ 3, every n-vertex graph with minimum degree at least n/2. Then G is hamiltonian. Proof. Let P be a longest path in G; suppose P is a uv-path. By the last lemma, it is sufficient to find a cycle C ⊂ G with V (P ) = V (C). If {u, v} ∈ E(G), then P +{u, v} forms the required cycle C. If {u, v} ̸∈ E(G), observe that NG (u) ⊆ V (P ) and NG (v) ⊆ V (P ) since P is a longest path. Then |NG (v)+ | = |NG (v)| = dG (v). Since dG (u) + dG (v) ≥ n and u ̸∈ NG (u) ∪ NG (v + ), NG (u) ∩ NG (v)+ ̸= ∅. In other words, there exists w ∈ NG (v) such that w+ ∈ NG (u). Now C = P + {u, w+ } + {v, w} − {w, w+ } is the required cycle. Theorem 4 is best possible, in light of graphs comprising two complete graphs of size ⌊n/2⌋ + 1 and ⌈n/2⌉ sharing exactly one vertex. This theorem has been generalized in many ways and their is a vast literature on sufficient conditions for a graph to contains long paths and cycles, and in particular hamiltonian paths and cycles. In fact, the proof of the theorem shows that if G is a graph and u, v are non-adjacent vertices in G such that dG (u) + dG (v) ≥ n, then G is hamiltonian if and only if G + {u, v} is hamiltonian. Bondy [3] introduced the notion of the closure of an n-vertex graph, namely, repeatedly add edges between non-adjacent vertices with degree sum at least n. The closure of a graph G satisfying the conditions of Theorem 4 is Kn , which is clearly hamiltonian, implying that the original graph G must be hamiltonian.

3

The above theorem applies to graphs that are very dense. Next we see that the main ideas can be extended to graphs which are sparse. For a set S ⊆ V (G), let ∪ Γ(S) = {NG (v) : v ∈ S}\S. The following theorem is due to P´osa [11]: Theorem 5. Let G be an n-vertex graph and suppose that for every set S ⊆ V (G), |Γ(S)| ≥ min{n − |S|, 2|S| + 1}. Then G contains a hamiltonian path. Proof. Let P be a longest path in G and let S be the set of all ends of paths obtained by repeated rotations from P which preserve the first vertex of P . Then no vertex in V (G)\V (P ) has a neighbor in S. Next we claim NG (v) ⊆ S∪S − ∪S + for every v ∈ S. For if there is w ∈ NG (v)\(S∪S + ∪S − ), then we could perform a rotation on a longest path ending at v to get a new path that ends at w+ or w− , in which case w+ ∈ S or w− ∈ S, respectively. This implies w ∈ S − or w ∈ S + , respectively, contradicting w ∈ NG (v)\(S ∪ S + ∪ S − ), proving the claim. In particular, Γ(S) ∪ S ⊂ S ∪ S + ∪ S − and so |Γ(S)| ≤ 2|S|. It follows that |Γ(S)| ≥ n − |S|. Since V (P ) ⊇ Γ(S) ∪ S, |V (P )| = n and P is a hamiltonian path. The complete bipartite graph Ka,n−a with a = ⌊n/2⌋ − 1 shows that this theorem is best possible. P´osa’s Theorem has many applications; for instance we shall see how to use it to show that random and pseudorandom graphs are hamiltonian.

1.3

Longest cycles in blocks

A block is a 2-connected graph i.e. a graph with no cutvertex. If G is a graph with δ(G) ≥ d, then G contains a cycle of length at least d + 1 and this is best possible. Dirac [4] improved this result for n-vertex blocks G with δ(G) ≥ d, showing that they contain a cycle of length at least min{n, 2d}. Before we prove Dirac’s Theorem, we need the following lemma of Bondy [3]: Lemma 6. Let G1 , G2 be two vertex-disjoint blocks in a block G and let Q be a path with V (G1 ) ∩ V (Q) = {x} and V (G2 ) ∩ V (Q) = {y}. Then there exist x0 ∈ V (G1 ) and y0 ∈ V (G2 ) and vertex-disjoint paths Q1 and Q2 such that V (Q1 ∪Q2 )∩V (G1 ) = {x0 , x} and V (Q1 ∪ Q2 ) ∩ V (G2 ) = {y0 , y}.

4



Figure 2: Paths Q1 and Q2 The proof of this lemma is left as an exercise. We use the lemma to prove the following theorem of Dirac [4]. This theorem implies Theorem 4, since it is easy to check that an n-vertex graph with dG (u) + dG (v) ≥ n for any two non-adjacent vertices u, v of G is a block. Theorem 7. Let P be a path in a block G, with ends u, v, and let H = G[V (P )]. If dH (u) + dH (v) ≥ d, then there exists a cycle in G of length at least min{|V (P )|, d}. In particular, if G is an n-vertex block with δ(G) ≥ d, then G contains a cycle of length at least min{n, 2d}. Proof. Orient P from u to v. If NH (u)∩NH (v)+ ̸= ∅, then pick w ∈ NH (u)∩NH (v)+ and form the cycle P +{u, w+ } +{v, w}− {w, w+ }, of length |V (P )|, as required. So we assume NH (u)∩NH (v)+ = ∅. We consider two cases. First, suppose some vertex in NH (v) comes before some vertex in NH (u). Pick two vertices x ∈ NH (v) and y ∈ NH (u) as close together on P as possible, with x coming before y. Let E be the set of edges of P on the subpath from x to y. Then C = P − E + {u, y} + {v, x} is a cycle that contains NH (v)+ \{x+ } and contains NH (u). Since NH (u) ∩ NH (v)+ = ∅, and |NH (v)+ | = dH (v), C has length at least |NH (u)| + |NH (v)+ \{x+ }| + 1 ≥ dH (u)+dH (v), as required. Here we noted that u is not counted in NH (u)∪NH (v)+ . Next, suppose no vertex in NH (v) comes before any vertex of NH (u). Let Pu and Pv be the minimal subpaths of P containing the vertices of NH (u)∪{u} and NH (v)∪{v} 5

respectively, and let G1 = H[V (Pu )] and G2 = H[V (Pv )]. Let x ∈ NH (u) be the last vertex of Pu and let y ∈ NH (v) be the first vertex of Pv . Then let Q be the subpath of P with one ends x and y. Since G1 and G2 are hamiltonian, they are blocks. By Bondy’s Lemma, there exist vertices x0 ∈ V (G1 ) and y0 ∈ V (G2 ) and vertex-disjoint paths Q1 , Q2 with V (Q1 ∪ Q2 ) ∩ V (G1 ) = {x0 , x} and V (Q1 ∪ Q2 ) ∩ V (G2 ) = {y0 , y}. Since x is adjacent to u in G1 , there exists a path P1 ⊂ H1 with ends x0 and x such that NH (u) ∪ {u} ⊂ V (P1 ), and the same holds in H2 . Now P1 ∪ P2 ∪ Q1 ∪ Q2 is a cycle of length at least |NH (u)| + |NH (v)| + 2 ≥ dH (u) + dH (v) + 2. This result is best possible, since for d ≥ 2, the complete bipartite graph Kd,n−d is a block and has no cycle of length more than 2d.

2

The Erd˝ os-Gallai Theorem

The pure extremal problem for paths is to determine ex(n, Pk ). We use the ingenious approach of Kopylov [9] to prove the Erd˝os-Gallai Theorem [6]: Theorem 8. Let k ≥ 2 and let G be an n-vertex graph containing no path of length k. Then e(G) ≤ (k − 1)n/2, with equality if and only if k|n and every component of G is Kk . To prove this theorem, we attack the extremal problem for paths in connected graphs. This is achieved by solving the extremal problem for long cycles in blocks: namely, if G is an n-vertex block containing no cycle of length at least k, how many edges can G have? The following theorem is due to Kopylov [9], for which we recall the definition of the graphs Hℓ,m,n . Theorem 9. Let k > 4, n ≥ k, and ℓ = ⌈k/2⌉ − 1. Let G be an n-vertex block with no cycle of length at least k. Then e(G) ≤ max{e(Hℓ,k−ℓ,n ), e(H2,k−2,n )}. Equality holds if and only if G ∈ {Hℓ,k−ℓ,n , H2,k−2,n }. Proof. We prove the upper bound on e(G) and leave the classification of extremal graphs to the reader. Suppose G is a graph with e(G) larger than the upper bound in the theorem. We may assume that the addition of any edge to G creates a cycle 6

of length at least k, so that in particular, every pair of non-adjacent vertices of G is the pair of ends of a path of length at least k − 1 in G. Since e(G) > e(Hℓ,k−ℓ,n ), by Proposition 1 there exists a non-empty (ℓ + 1)-core H ⊆ G. We consider two cases. Case 1. H is not a complete graph. Any pair of non-adjacent vertices of H are the ends of a path P ⊂ G of length at least k − 1. Let P be a longest such path with ends u, v ∈ V (H). Then NH (u) ⊆ V (P ) and NH (v) ⊆ V (P ). By Dirac’s Theorem, there is a cycle C ⊂ G of length at least min{|V (P )|, 2ℓ + 2} ≥ k, as required. Case 2. H is a complete graph. Let h = |V (H)| and observe k − h ≤ ℓ + 2 ≤ h. By Proposition 1, since e(G) > e(Hk−h,h,n ), there is a (k − h + 1)-core J ⊂ G with |V (J)| ≥ h + 1 > |V (H)|. This means some x ∈ V (J) is nonadjacent to some y ∈ V (H), otherwise G[V (H) ∪ {x}] is the (ℓ + 1)-core of G. Pick x ∈ V (J) and y ∈ V (H) so that the length of a longest xy-path P in G is maximized, and note |V (P )| ≥ k. Then NJ (x) ⊆ V (P ) and NH (y) ⊆ V (P ), and |NJ (x)| ≥ k − h + 1 and |N( y)| ≥ ℓ + 1. By Dirac’s Theorem, G contains a cycle of length at least min{k, |NJ (x)| + |NH (y)|} ≥ min{k, k − h + 1 + h − 1} = k. This completes the proof. We remark that for k > 4, the extremal function in Theorem 9 is strictly less than (k − 1)n/2. Theorem 9 cannot be extended to k ≤ 4, since any block with at least four vertices automatically contains a cycle of length at least four. We also remark that the extremal graph H2,k−2,n only appears when n ≤ 2k − 2 − (3/2)⌈k/2⌉. In particular, if n ≥ 5k/4, the unique extremal graphs are Hℓ,k−ℓ,n . From the above theorem, we prove the Erd˝os-Gallai Theorem: Proof. Let G be an n-vertex graph with e(G) ≥ (k − 1)n/2 and no path of length k. In the case k = 2, all edges of the graph are vertex-disjoint, so e(G) ≤ n/2 with equality only if G is a disjoint union of K2 components. Now suppose k > 2. Add a vertex x to G adjacent to all vertices in G: denote this by G + x. Let H1 , H2 , . . . , Hr be the components of G, with |V (Hi )| = ni . Then Hi + x is a block. If Hi + x contains a cycle of length at least k + 2, then clearly Hi contains a path of length k, a contradiction. So Hi + x contains no cycle of length at least k + 2. Since k + 2 > 4, Theorem 9 applies. If ni ≥ k + 1, then by Theorem 9, e(Hi ) + ni = e(Hi + x) ≤ max{e(Hℓ,k−ℓ,ni +1 ), e(H2,k−2,ni +1 )} < 21 (k − 1)ni + ni . 7

( ) If ni ≤ k, then e(Hi ) ≤ n2i ≤ (k − 1)ni /2 with equality only if Hi = Kk . We conclude e(Hi ) ≤ 21 (k − 1)ni with equality if and only if Hi = Kk . Since e(G) ≥ (k − 1)n/2, it follows that k|n and every component of G is Kk . Recently stability versions of these results have been found by F¨ uredi, Kostochka and the author, and in particular, the following theorem is proved: Theorem 10. Let k ≥ 3 be odd, ℓ = ⌈k/2⌉ − 1 and n ≥ k, and let G be an n-vertex ( ) graph such that e(G) ≥ (ℓ − 1)(n − ℓ + 1) + ℓ−1 2 . Then G contains a cycle of length at least k unless G ⊆ Hℓ+1,ℓ+1,n .

3

Counting paths and walks

A walk of length k in a graph G is an alternating sequence (v1 , e1 , v2 , e2 , . . . , vk , ek , vk+1 ) of vertices vi ∈ V (G) and edges ei ∈ E(G) such that ei = {vi , vi+1 } for i ≤ k. A walk (v1 , e1 , v2 , e2 , . . . , vk , ek , vk+1 ) is non-backtracking if ei ̸= ei+1 for all i ≤ k. If G is a d-regular graph, then clearly G has at least ndk walks of length k and at least nd(d − 1)k−1 non-backtracking walks of length k. As it turns out, regular graphs have the minimum number of walks of length k, due to the following result of Alon, Hoory and Linial [1]: Theorem 11. Let G be an n-vertex graph with average degree d. The G contains at least ndk walks of length k and at least nd(d − 1)k−1 non-backtracking walks of length k, with equality if and only if G is a d-regular graph. There are many proofs of this theorem, the first for walks of length k was given by Blakley and Roy [2] in the form of a matrix H¨older Inequality on the adjacency matrix of the graph. We return to those techniques slightly later in the text. The case k = 2 clearly follows from the convexity of f (x) = x(x − 1). Proof. We may ignore isolated vertices. Let Nuv be the set of walks of length k which start with vertices u and v in that order. The total number of walks of length k in G is ∑ N= |Nuv |. (u,v)

8

For each walk W which starts with u, v, we may define P(W ) =

1 n



dG (v)−f (u,v)

u,v∈V (G)

where f (u, v) is the number of times the walk traverses edge {u, v} from u to v To see that this is a well defined probability on walks, consider a random walk ω of length k on G, where we start at a uniformly chosen edge, and if the walk is at vertex v at some stage, then an edge on v is chosen uniformly with probability 1/dG (v). The transition matrix is thus the matrix A whose dn rows and dn columns are indexed by (u, v) : {u, v} ∈ E(G) and where A(u,v),(v,w) = 1/dG (v) for any edges {u, v}, {v, w} ∈ E(G). The stationary distribution of the walk is given by the constant vector ⃗x whose entries are all 1/dn and then P(W ) = P(ω = W ). We conclude: ∑ ∑ ∑ P(W ) N= |Nuv | = P(W ) (u,v) (u,v) W ∈Nuv ∏ ∏ ≥ dn P(W )−P(W )/dn = dn

(u,v) W ∈Nuv ∑ ∏

dG (v)

(u,v)

= dn



1 (x,y) dn

∑k−1

dG (v)

i=0

∑ W ∈Nxy

f (u,v)P(W )

(⃗ xAi )(u,v)

(u,v)

= dn



dG (v)(k−1)/dn

(u,v)

= dn



dG (v)(k−1)dG (v)/dn ≥ ndk .

v∈V (G)

In the second line and last line, we used the inequality of arithmetic and geometric means. The proof for non-backtracking walks follows the same lines, except we may assume dG (v) ≥ 2 for all v ∈ V (G), and the transition matrix A has A(u,v),(v,w) = 1/(dG (v) − 1) for all v ∈ V (G) This theorem will be used to give bounds on ex(n, {C3 , C4 , . . . , Ck }). The proof given above can be adapted to counting homomorphisms and local isomorphisms of trees. If G is a graph and T is a tree, then a homomorphism of T in G is a map f : V (T ) → V (G) such that if {u, v} ∈ E(T ) then {f (u), f (v)} ∈ E(G). In other words, f is an edge-preserving map, although f may not be injective. A local 9

isomorphism of T in G is a homomorphism f : V (T ) → V (G) such that for every v ∈ V (T ), f restricted to N (v) is an injection. In other words, f is neighborhoodpreserving. The following theorem was proved by Hoory, Lazebnik and the author and the first part of the theorem was proved independently by Dellamonica et. al [5]. We define d(r) := d(d − 1)(d − 2) . . . (d − r + 1), and δ(G) and △(G) are the minimum and the maximum degree of a graph G, respectively. Theorem 12. Let T be a tree with degree sequence (d1 , d2 , . . . , dk ). Then the number of homomorphisms of T in an n-vertex graph G of average degree d is at least ∏

dn

dG (v)(k−2)

dG (v) dn

≥ ndk−1 .

v∈V (G)

If δ(G) ≥ △(T ), then the number of local isomorphisms of T in G is at least dn

k ∏ ∏

dG (v) dn (di −1)

(dG (v) − 1)

≥ nd

v∈V (G) i=1

k ∏

(d − 1)(di −1) .

i=1

This theorem may offer another approach to proving the Erd˝os-S´os Conjecture, namely by showing that if T is any tree with k edges and G is any graph with average degree more than k − 1, then the number of homomorphic copies of T in G exceeds the number of non-isomorphic copies of T in G. In the special case of paths, it seems plausible that every graph of average degree d ≥ k with n vertices contains at least dn



dG (v)

dn (dG (v) − 1)(k−1) ≥ nd(k)

v∈V (G)

paths of length k. A slightly weaker statement is proved for k = 3 in [5]. Erd˝os and Simonovits [7] gave a structural combinatorial argument showing that if a graph G of average degree d has N walks of length k, then as d → ∞, the number of paths of length k is N − o(N ). If G has n vertices, then by Theorem 11, N ≥ ndk , we see that there are n(dk − o(dk ) paths of length k in every n-vertex graph of average degree d. These results are special cases of a more general framework introduced by Sidorenko [12] on counting homomorphic copies of a bipartite graph F in a graph G, to which we shall return later.

10

3.1

Counting walks by linear algebra

A natural way to encode the number of walks of length k between pairs of vertices in a graph is the adjacency matrix of the graph. Indeed, for a graph G with adjacency matrix A and vertices u, v ∈ V (G), the entry (Ak )uv is the number of uv-walks of length k in G. Using basic linear algebra, when k is even, we can then recover the lower bound in Theorem 11 on walks of length k as follows: For vectors x, y ∈ Rn , ∑ Denote by ⟨x, y⟩ the standard Euclidean scalar product ni=1 xi yi . Theorem 13. Let A be a symmetric matrix and let x ∈ Rn be a unit vector, such ⟨ ⟩ that A and x are entrywise non-negative. Then Ak x, x ≥ ⟨Ax, x⟩k . In particular, a graph of average degree at least d has at least ndk walks of length k. Proof. Since A is a symmetric, A may be diagonalized to obtain a diagonal matrix Λ = X −1 AX whose entries are the eigenvalues of A, say λ1 , λ2 , . . . , λn . Here X consists of the eigenvectors x1 , x2 , . . . , xn from an orthonormal basis. Writing x = a1 x1 + a2 x2 + · · · + an xn , we have ⟨Ax, x⟩ =

n ∑

λi a2i .

i=1

Since ⟨x, x⟩ = 1 since x is a unit vector, we have a21 + a22 + · · · + a2k = 1. Since A = XΛX −1 , Ak = XΛk X −1 and n ⟨ ⟩ ∑ Ak x, x = λki a2i . i=1

If k is even, then by Jensen’s Inequality, ⟨

k



A x, x =

n ∑

λki a2i



n (∑

i=1

λi a2i

)2

= ⟨Ax, x⟩k .

i=1

This completes the proof for k even. For k odd, this does not work since some of the λki are negative. This case is more complicated, and was dealt with by Blakley and Roy [2] via a geometric argument as follows. Case 1. x has a zero entry. If xj = 0, then strike entry j from x to obtain a non-negative unit vector y in Rn−1 . If we strike from A the jth row and column, we ⟨ ⟩ get a symmetric non-negative matrix B. By induction on n, we conclude B k y, y ≥ 11

⟨ ⟩ ⟨ ⟩ ⟨By, y⟩k . However, ⟨By, y⟩k = ⟨Ax, x⟩k whereas B k y, y ≤ Ak x, x , and the proof is complete. Case 2. x has no zero entry. By renormalization, we may assume that the largest eigenvalue of A is 1 with corresponding non-negative unit eigenvector z. If x is an ⟨ ⟩ eigenvector of A with eigenvalue 1, then we are done since Ak x, x = ⟨Ax, x⟩k = 1 in that case. So we assume x is not an eigenvector of A with eigenvalue 1. Then there is a unit vector y orthogonal to z such that x = αz + βy where α2 + β 2 = 1 and α, β ≥ 0. Note that ⟨Ay, y⟩ < 1 otherwise x would be an eigenvector of A with eigenvalue 1. Now select a non-negative unit vector w such that w has a zero entry 2 and w = αz + βy where 0 ≤ α ≤ α and β ≥ 0 and α2 + β = 1 (see Figure 3).

Figure 3: Vectors x, y, z, w ⟨ ⟩ By Case 1, ⟨Aw, w⟩k ≤ Ak w, w . Finally, consider f : [0, 1] → R defined by ⟨ k ⟩ A y, y − 1 k f (t) = 1 − t + (t − 1). ⟨Ay, y⟩ − 1 ⟨ ⟩ ⟨ ⟩ Then f (1) = 0 and f (⟨Ax, x⟩) = Ak x, x − ⟨Ax, x⟩k and f (⟨Aw, w⟩) = Ak w, w − ⟨Aw, w⟩k ≥ 0. As f is convex on [0, 1], ⟨Aw, w⟩ ≤ ⟨Ax, x⟩ ≤ 1, f (⟨Ax, x⟩) ≥ 0. Finally, we note that if A is the adjacency matrix of an n-vertex graph G with average √ degree d, and x is the constant unit vector with entries 1/ n, then ⟨Ax, x⟩k = d ⟨ k ⟩ and so we see that the number of walks of length k is n A x, x ≥ ndk . There are a number of other proofs of the above result, including the one using the so-called tensor trick (see Problem Sheet 2). It appears to be difficult to encode ∏ counting paths using linear algebra; perhaps one might consider k−1 i=0 (A − iI) for lower bounds on the number of paths of length k, where I is the identity matrix. 12

References [1] N. Alon, S. Hoory and N. Linial, The Moore bound for irregular graphs, Graphs and Combinatorics 18 (2002), 53–57. [2] G. Blakley, P. Roy, A H¨older type inequality for symmetric matrices with nonnegative entries. Proc. Amer. Math. Soc. 16 (1965) 1244–1245. [3] J. A. Bondy, Basic graph theory: paths and circuits, Handbook of Combinatorics, Vol. 1, Elsevier, Amsterdam, (1995) 3–110. [4] G. A. Dirac, Some theorems on abstract graphs, Proceedings of the London Mathematical Society, 3rd Ser. 2 (1952) 69–81. [5] D. Dellamonica, P. Haxell, T. Luczak, D. Mubayi, B. Nagle, Y. Person, V. R¨odl, M. Schacht, Tree-minimal graphs are almost regular. J. Comb. 3 (2012), no. 1, 49-62. [6] P. Erd˝os and T. Gallai, On maximal paths and circuits of graphs, Acta Math. Acad. Sci. Hungar. 10 (1959), 337–356. [7] P. Erd˝os and M . Simonovits, Compactness results in extremai graph theory, Combinatorica, 3 (2) (1983) 275–288. [8] P. Erd˝os, Some problems in graph theory, Theory of Graphs and Its Applications, M. Fiedler, Editor, Academic Press, New York, 1965, pp. 29–36. [9] G. N. Kopylov, On maximal path and cycles in a graph, Dokl. Akad. Nauk SSSR 234 (1977), (Soviet Math. Dokl. 18 (1977), 593–596.) [10] O. Ore, Note on Hamilton circuits, American Mathematical Monthly 67 (1960) (1) 55. [11] L. P´osa, On the circuits of finite graphs, Magyar Tud Akad Mat Kutat´o Int K˝ozl 8 (1963/1964), 355–361. [12] A. Sidorenko, A correlation inequality for bipartite graphs. Graphs Combin. 9 (1993), no. 2, 201–204.

13